VTK: vtkLight Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkLight Class Reference

a virtual light for 3D rendering More...

`#include <vtkLight.h>`

Inheritance diagram for vtkLight:
[legend]
Collaboration diagram for vtkLight:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkLight * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual vtkLight * | ShallowClone ()
| Create a new light object with the same light parameters than the current object (any ivar from the superclasses (vtkObject and vtkObjectBase), like reference counting, timestamp and observers are not copied). More...
virtual void | Render (vtkRenderer *, int)
| Abstract interface to renderer. More...
void | TransformPoint (double a[3], double b[3])
| Use transform matrix to transform point (if it exists). More...
void | TransformVector (double a[3], double b[3])
| Use transform matrix to transform vector (if it exists). More...
void | DeepCopy (vtkLight *light)
| Perform deep copy of this light. More...
virtual void | SetAmbientColor (double, double, double)
| Set/Get the color of the light. More...
virtual void | SetAmbientColor (double[3])
| Set/Get the color of the light. More...
virtual double * | GetAmbientColor ()
| Set/Get the color of the light. More...
virtual void | GetAmbientColor (double data[3])
| Set/Get the color of the light. More...
virtual void | SetDiffuseColor (double, double, double)
| Set/Get the color of the light. More...
virtual void | SetDiffuseColor (double[3])
| Set/Get the color of the light. More...
virtual double * | GetDiffuseColor ()
| Set/Get the color of the light. More...
virtual void | GetDiffuseColor (double data[3])
| Set/Get the color of the light. More...
virtual void | SetSpecularColor (double, double, double)
| Set/Get the color of the light. More...
virtual void | SetSpecularColor (double[3])
| Set/Get the color of the light. More...
virtual double * | GetSpecularColor ()
| Set/Get the color of the light. More...
virtual void | GetSpecularColor (double data[3])
| Set/Get the color of the light. More...
void | SetColor (double, double, double)
| Set/Get the color of the light. More...
void | SetColor (const double a[3])
| Set/Get the color of the light. More...
virtual void | SetPosition (double, double, double)
| Set/Get the position of the light. More...
virtual void | SetPosition (double[3])
| Set/Get the position of the light. More...
virtual double * | GetPosition ()
| Set/Get the position of the light. More...
virtual void | GetPosition (double data[3])
| Set/Get the position of the light. More...
void | SetPosition (const float *a)
| Set/Get the position of the light. More...
virtual void | SetFocalPoint (double, double, double)
| Set/Get the point at which the light is shining. More...
virtual void | SetFocalPoint (double[3])
| Set/Get the point at which the light is shining. More...
virtual double * | GetFocalPoint ()
| Set/Get the point at which the light is shining. More...
virtual void | GetFocalPoint (double data[3])
| Set/Get the point at which the light is shining. More...
void | SetFocalPoint (const float *a)
| Set/Get the point at which the light is shining. More...
virtual void | SetIntensity (double)
| Set/Get the brightness of the light (from one to zero). More...
virtual double | GetIntensity ()
| Set/Get the brightness of the light (from one to zero). More...
virtual void | SetSwitch (vtkTypeBool)
| Turn the light on or off. More...
virtual vtkTypeBool | GetSwitch ()
| Turn the light on or off. More...
virtual void | SwitchOn ()
| Turn the light on or off. More...
virtual void | SwitchOff ()
| Turn the light on or off. More...
virtual void | SetPositional (vtkTypeBool)
| Turn positional lighting on or off. More...
virtual vtkTypeBool | GetPositional ()
| Turn positional lighting on or off. More...
virtual void | PositionalOn ()
| Turn positional lighting on or off. More...
virtual void | PositionalOff ()
| Turn positional lighting on or off. More...
virtual void | SetExponent (double)
| Set/Get the exponent of the cosine used in positional lighting. More...
virtual double | GetExponent ()
| Set/Get the exponent of the cosine used in positional lighting. More...
virtual void | SetConeAngle (double)
| Set/Get the lighting cone angle of a positional light in degrees. More...
virtual double | GetConeAngle ()
| Set/Get the lighting cone angle of a positional light in degrees. More...
virtual void | SetAttenuationValues (double, double, double)
| Set/Get the quadratic attenuation constants. More...
virtual void | SetAttenuationValues (double[3])
| Set/Get the quadratic attenuation constants. More...
virtual double * | GetAttenuationValues ()
| Set/Get the quadratic attenuation constants. More...
virtual void | GetAttenuationValues (double data[3])
| Set/Get the quadratic attenuation constants. More...
virtual void | SetTransformMatrix (vtkMatrix4x4 *)
| Set/Get the light's transformation matrix. More...
virtual vtkMatrix4x4 * | GetTransformMatrix ()
| Set/Get the light's transformation matrix. More...
void | GetTransformedPosition (double &x, double &y, double &z)
| Get the position of the light, modified by the transformation matrix (if it exists). More...
void | GetTransformedPosition (double a[3])
| Get the position of the light, modified by the transformation matrix (if it exists). More...
double * | GetTransformedPosition ()
| Get the position of the light, modified by the transformation matrix (if it exists). More...
void | GetTransformedFocalPoint (double &x, double &y, double &z)
| Get the focal point of the light, modified by the transformation matrix (if it exists). More...
void | GetTransformedFocalPoint (double a[3])
| Get the focal point of the light, modified by the transformation matrix (if it exists). More...
double * | GetTransformedFocalPoint ()
| Get the focal point of the light, modified by the transformation matrix (if it exists). More...
void | SetDirectionAngle (double elevation, double azimuth)
| Set the position and focal point of a light based on elevation and azimuth. More...
void | SetDirectionAngle (const double ang[2])
| Set the position and focal point of a light based on elevation and azimuth. More...
virtual void | SetLightType (int)
| Set/Get the type of the light. More...
virtual int | GetLightType ()
| Set/Get the type of the light. More...
void | SetLightTypeToHeadlight ()
| Set/Get the type of the light. More...
void | SetLightTypeToSceneLight ()
| Set/Get the type of the light. More...
void | SetLightTypeToCameraLight ()
| Set/Get the type of the light. More...
int | LightTypeIsHeadlight ()
| Query the type of the light. More...
int | LightTypeIsSceneLight ()
| Query the type of the light. More...
int | LightTypeIsCameraLight ()
| Query the type of the light. More...
virtual void | SetShadowAttenuation (float)
| Set/Get the shadow intensity By default a light will be completely blocked when in shadow by setting this value to less than 1.0 you can control how much light is attenuated when in shadow. More...
virtual float | GetShadowAttenuation ()
| Set/Get the shadow intensity By default a light will be completely blocked when in shadow by setting this value to less than 1.0 you can control how much light is attenuated when in shadow. More...
virtual vtkInformation * | GetInformation ()
| Set/Get the information object associated with the light. More...
virtual void | SetInformation (vtkInformation *)
| Set/Get the information object associated with the light. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkLight * | SafeDownCast (vtkObjectBase *o)
static vtkLight * | New ()
| Create a light with the focal point at the origin and its position set to (0,0,1). More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkLight ()
| ~vtkLight () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
double | FocalPoint [3]
double | Position [3]
double | Intensity
double | AmbientColor [3]
double | DiffuseColor [3]
double | SpecularColor [3]
vtkTypeBool | Switch
vtkTypeBool | Positional
double | Exponent
double | ConeAngle
double | AttenuationValues [3]
vtkMatrix4x4 * | TransformMatrix
double | TransformedFocalPointReturn [3]
double | TransformedPositionReturn [3]
int | LightType
float | ShadowAttenuation
vtkInformation * | Information
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

a virtual light for 3D rendering

vtkLight is a virtual light for 3D rendering. It provides methods to locate and point the light, turn it on and off, and set its brightness and color. In addition to the basic infinite distance point light source attributes, you also can specify the light attenuation values and cone angle. These attributes are only used if the light is a positional light. The default is a directional light (e.g. infinite point light source).

Lights have a type that describes how the light should move with respect to the camera. A Headlight is always located at the current camera position and shines on the camera's focal point. A CameraLight also moves with the camera, but may not be coincident to it. CameraLights are defined in a normalized coordinate space where the camera is located at (0, 0, 1), the camera is looking at (0, 0, 0), and up is (0, 1, 0). Finally, a SceneLight is part of the scene itself and does not move with the camera. (Renderers are responsible for moving the light based on its type.)

Lights have a transformation matrix that describes the space in which they are positioned. A light's world space position and focal point are defined by their local position and focal point, transformed by their transformation matrix (if it exists).

Online Examples:

Tests:
  vtkLight (Tests)

Definition at line 57 of file vtkLight.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkLight::Superclass

Definition at line 60 of file vtkLight.h.

## Constructor & Destructor Documentation

## ◆ vtkLight()

vtkLight::vtkLight | ( |  | ) |
| protected

## ◆ ~vtkLight()

vtkLight::~vtkLight | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkLight::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkLight::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

Reimplemented in vtkWebGPULight, vtkOpenGLLight, vtkExternalLight, and vtkRIBLight.

## ◆ SafeDownCast()

static vtkLight* vtkLight::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkLight::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented in vtkWebGPULight, vtkOpenGLLight, vtkExternalLight, and vtkRIBLight.

## ◆ NewInstance()

vtkLight* vtkLight::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkLight::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

Reimplemented in vtkWebGPULight, vtkOpenGLLight, and vtkExternalLight.

## ◆ New()

static vtkLight* vtkLight::New | ( |  | ) |
| static

Create a light with the focal point at the origin and its position set to (0,0,1).

The light is a SceneLight, its color is white (black ambient, white diffuse, white specular), intensity=1, the light is turned on, positional lighting is off, ConeAngle=30, AttenuationValues=(1,0,0), Exponent=1 and the TransformMatrix is NULL.

## ◆ ShallowClone()

virtual vtkLight* vtkLight::ShallowClone | ( |  | ) |
| virtual

Create a new light object with the same light parameters than the current object (any ivar from the superclasses (vtkObject and vtkObjectBase), like reference counting, timestamp and observers are not copied).

This is a shallow clone (TransformMatrix is referenced)

## ◆ Render()

virtual void vtkLight::Render | ( | vtkRenderer * | ,
|  | int |
| ) |  |
| inlinevirtual

Abstract interface to renderer.

Each concrete subclass of vtkLight will load its data into the graphics system in response to this method invocation. The actual loading is performed by a vtkLightDevice subclass, which will get created automatically.

Reimplemented in vtkOpenGLLight, vtkRIBLight, and vtkWebGPULight.

Definition at line 87 of file vtkLight.h.

## ◆ SetAmbientColor() [1/2]

virtual void vtkLight::SetAmbientColor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

Reimplemented in vtkExternalLight.

## ◆ SetAmbientColor() [2/2]

virtual void vtkLight::SetAmbientColor | ( | double | [3] | ) |
| virtual

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

## ◆ GetAmbientColor() [1/2]

virtual double* vtkLight::GetAmbientColor | ( |  | ) |
| virtual

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

## ◆ GetAmbientColor() [2/2]

virtual void vtkLight::GetAmbientColor | ( | double | data[3] | ) |
| virtual

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

## ◆ SetDiffuseColor() [1/2]

virtual void vtkLight::SetDiffuseColor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

Reimplemented in vtkExternalLight.

## ◆ SetDiffuseColor() [2/2]

virtual void vtkLight::SetDiffuseColor | ( | double | [3] | ) |
| virtual

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

## ◆ GetDiffuseColor() [1/2]

virtual double* vtkLight::GetDiffuseColor | ( |  | ) |
| virtual

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

## ◆ GetDiffuseColor() [2/2]

virtual void vtkLight::GetDiffuseColor | ( | double | data[3] | ) |
| virtual

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

## ◆ SetSpecularColor() [1/2]

virtual void vtkLight::SetSpecularColor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

Reimplemented in vtkExternalLight.

## ◆ SetSpecularColor() [2/2]

virtual void vtkLight::SetSpecularColor | ( | double | [3] | ) |
| virtual

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

## ◆ GetSpecularColor() [1/2]

virtual double* vtkLight::GetSpecularColor | ( |  | ) |
| virtual

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

## ◆ GetSpecularColor() [2/2]

virtual void vtkLight::GetSpecularColor | ( | double | data[3] | ) |
| virtual

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

## ◆ SetColor() [1/2]

void vtkLight::SetColor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

## ◆ SetColor() [2/2]

void vtkLight::SetColor | ( | const double | a[3] | ) |
| inline

Set/Get the color of the light.

It is possible to set the ambient, diffuse and specular colors separately. The SetColor() method sets the diffuse and specular colors to the same color (this is a feature to preserve backward compatibility.)

Definition at line 103 of file vtkLight.h.

## ◆ SetPosition() [1/3]

virtual void vtkLight::SetPosition | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the position of the light.

Note: The position of the light is defined in the coordinate space indicated by its transformation matrix (if it exists). Thus, to get the light's world space position, use vtkGetTransformedPosition() instead of vtkGetPosition().

Reimplemented in vtkExternalLight.

## ◆ SetPosition() [2/3]

virtual void vtkLight::SetPosition | ( | double | [3] | ) |
| virtual

Set/Get the position of the light.

Note: The position of the light is defined in the coordinate space indicated by its transformation matrix (if it exists). Thus, to get the light's world space position, use vtkGetTransformedPosition() instead of vtkGetPosition().

## ◆ GetPosition() [1/2]

virtual double* vtkLight::GetPosition | ( |  | ) |
| virtual

Set/Get the position of the light.

Note: The position of the light is defined in the coordinate space indicated by its transformation matrix (if it exists). Thus, to get the light's world space position, use vtkGetTransformedPosition() instead of vtkGetPosition().

## ◆ GetPosition() [2/2]

virtual void vtkLight::GetPosition | ( | double | data[3] | ) |
| virtual

Set/Get the position of the light.

Note: The position of the light is defined in the coordinate space indicated by its transformation matrix (if it exists). Thus, to get the light's world space position, use vtkGetTransformedPosition() instead of vtkGetPosition().

## ◆ SetPosition() [3/3]

void vtkLight::SetPosition | ( | const float * | a | ) |
| inline

Set/Get the position of the light.

Note: The position of the light is defined in the coordinate space indicated by its transformation matrix (if it exists). Thus, to get the light's world space position, use vtkGetTransformedPosition() instead of vtkGetPosition().

Definition at line 116 of file vtkLight.h.

## ◆ SetFocalPoint() [1/3]

virtual void vtkLight::SetFocalPoint | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the point at which the light is shining.

Note: The focal point of the light is defined in the coordinate space indicated by its transformation matrix (if it exists). Thus, to get the light's world space focal point, use vtkGetTransformedFocalPoint() instead of vtkGetFocalPoint().

Reimplemented in vtkExternalLight.

## ◆ SetFocalPoint() [2/3]

virtual void vtkLight::SetFocalPoint | ( | double | [3] | ) |
| virtual

Set/Get the point at which the light is shining.

Note: The focal point of the light is defined in the coordinate space indicated by its transformation matrix (if it exists). Thus, to get the light's world space focal point, use vtkGetTransformedFocalPoint() instead of vtkGetFocalPoint().

## ◆ GetFocalPoint() [1/2]

virtual double* vtkLight::GetFocalPoint | ( |  | ) |
| virtual

Set/Get the point at which the light is shining.

Note: The focal point of the light is defined in the coordinate space indicated by its transformation matrix (if it exists). Thus, to get the light's world space focal point, use vtkGetTransformedFocalPoint() instead of vtkGetFocalPoint().

## ◆ GetFocalPoint() [2/2]

virtual void vtkLight::GetFocalPoint | ( | double | data[3] | ) |
| virtual

Set/Get the point at which the light is shining.

Note: The focal point of the light is defined in the coordinate space indicated by its transformation matrix (if it exists). Thus, to get the light's world space focal point, use vtkGetTransformedFocalPoint() instead of vtkGetFocalPoint().

## ◆ SetFocalPoint() [3/3]

void vtkLight::SetFocalPoint | ( | const float * | a | ) |
| inline

Set/Get the point at which the light is shining.

Note: The focal point of the light is defined in the coordinate space indicated by its transformation matrix (if it exists). Thus, to get the light's world space focal point, use vtkGetTransformedFocalPoint() instead of vtkGetFocalPoint().

Definition at line 129 of file vtkLight.h.

## ◆ SetIntensity()

virtual void vtkLight::SetIntensity | ( | double |  | ) |
| virtual

Set/Get the brightness of the light (from one to zero).

Reimplemented in vtkExternalLight.

## ◆ GetIntensity()

virtual double vtkLight::GetIntensity | ( |  | ) |
| virtual

Set/Get the brightness of the light (from one to zero).

## ◆ SetSwitch()

virtual void vtkLight::SetSwitch | ( | vtkTypeBool |  | ) |
| virtual

Turn the light on or off.

## ◆ GetSwitch()

virtual vtkTypeBool vtkLight::GetSwitch | ( |  | ) |
| virtual

Turn the light on or off.

## ◆ SwitchOn()

virtual void vtkLight::SwitchOn | ( |  | ) |
| virtual

Turn the light on or off.

## ◆ SwitchOff()

virtual void vtkLight::SwitchOff | ( |  | ) |
| virtual

Turn the light on or off.

## ◆ SetPositional()

virtual void vtkLight::SetPositional | ( | vtkTypeBool |  | ) |
| virtual

Turn positional lighting on or off.

Reimplemented in vtkExternalLight.

## ◆ GetPositional()

virtual vtkTypeBool vtkLight::GetPositional | ( |  | ) |
| virtual

Turn positional lighting on or off.

## ◆ PositionalOn()

virtual void vtkLight::PositionalOn | ( |  | ) |
| virtual

Turn positional lighting on or off.

## ◆ PositionalOff()

virtual void vtkLight::PositionalOff | ( |  | ) |
| virtual

Turn positional lighting on or off.

## ◆ SetExponent()

virtual void vtkLight::SetExponent | ( | double |  | ) |
| virtual

Set/Get the exponent of the cosine used in positional lighting.

Reimplemented in vtkExternalLight.

## ◆ GetExponent()

virtual double vtkLight::GetExponent | ( |  | ) |
| virtual

Set/Get the exponent of the cosine used in positional lighting.

## ◆ SetConeAngle()

virtual void vtkLight::SetConeAngle | ( | double |  | ) |
| virtual

Set/Get the lighting cone angle of a positional light in degrees.

This is the angle between the axis of the cone and a ray along the edge of the cone. A value of 90 (or more) indicates that you want no spot lighting effects just a positional light.

Reimplemented in vtkExternalLight.

## ◆ GetConeAngle()

virtual double vtkLight::GetConeAngle | ( |  | ) |
| virtual

Set/Get the lighting cone angle of a positional light in degrees.

This is the angle between the axis of the cone and a ray along the edge of the cone. A value of 90 (or more) indicates that you want no spot lighting effects just a positional light.

## ◆ SetAttenuationValues() [1/2]

virtual void vtkLight::SetAttenuationValues | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the quadratic attenuation constants.

They are specified as constant, linear, and quadratic, in that order.

Reimplemented in vtkExternalLight.

## ◆ SetAttenuationValues() [2/2]

virtual void vtkLight::SetAttenuationValues | ( | double | [3] | ) |
| virtual

Set/Get the quadratic attenuation constants.

They are specified as constant, linear, and quadratic, in that order.

## ◆ GetAttenuationValues() [1/2]

virtual double* vtkLight::GetAttenuationValues | ( |  | ) |
| virtual

Set/Get the quadratic attenuation constants.

They are specified as constant, linear, and quadratic, in that order.

## ◆ GetAttenuationValues() [2/2]

virtual void vtkLight::GetAttenuationValues | ( | double | data[3] | ) |
| virtual

Set/Get the quadratic attenuation constants.

They are specified as constant, linear, and quadratic, in that order.

## ◆ SetTransformMatrix()

virtual void vtkLight::SetTransformMatrix | ( | vtkMatrix4x4 * |  | ) |
| virtual

Set/Get the light's transformation matrix.

If a matrix is set for a light, the light's parameters (position and focal point) are transformed by the matrix before being rendered.

## ◆ GetTransformMatrix()

virtual vtkMatrix4x4* vtkLight::GetTransformMatrix | ( |  | ) |
| virtual

Set/Get the light's transformation matrix.

If a matrix is set for a light, the light's parameters (position and focal point) are transformed by the matrix before being rendered.

## ◆ GetTransformedPosition() [1/3]

void vtkLight::GetTransformedPosition | ( | double & | x,
|  | double & | y,
|  | double & | z
| ) |  |

Get the position of the light, modified by the transformation matrix (if it exists).

## ◆ GetTransformedPosition() [2/3]

void vtkLight::GetTransformedPosition | ( | double | a[3] | ) |

Get the position of the light, modified by the transformation matrix (if it exists).

## ◆ GetTransformedPosition() [3/3]

double* vtkLight::GetTransformedPosition | ( |  | ) |

Get the position of the light, modified by the transformation matrix (if it exists).

## ◆ GetTransformedFocalPoint() [1/3]

void vtkLight::GetTransformedFocalPoint | ( | double & | x,
|  | double & | y,
|  | double & | z
| ) |  |

Get the focal point of the light, modified by the transformation matrix (if it exists).

## ◆ GetTransformedFocalPoint() [2/3]

void vtkLight::GetTransformedFocalPoint | ( | double | a[3] | ) |

Get the focal point of the light, modified by the transformation matrix (if it exists).

## ◆ GetTransformedFocalPoint() [3/3]

double* vtkLight::GetTransformedFocalPoint | ( |  | ) |

Get the focal point of the light, modified by the transformation matrix (if it exists).

## ◆ TransformPoint()

void vtkLight::TransformPoint | ( | double | a[3],
|  | double | b[3]
| ) |  |

Use transform matrix to transform point (if it exists).

## ◆ TransformVector()

void vtkLight::TransformVector | ( | double | a[3],
|  | double | b[3]
| ) |  |

Use transform matrix to transform vector (if it exists).

## ◆ SetDirectionAngle() [1/2]

void vtkLight::SetDirectionAngle | ( | double | elevation,
|  | double | azimuth
| ) |  |

Set the position and focal point of a light based on elevation and azimuth.

The light is moved so it is shining from the given angle. Angles are given in degrees. If the light is a positional light, it is made directional instead.

## ◆ SetDirectionAngle() [2/2]

void vtkLight::SetDirectionAngle | ( | const double | ang[2] | ) |
| inline

Set the position and focal point of a light based on elevation and azimuth.

The light is moved so it is shining from the given angle. Angles are given in degrees. If the light is a positional light, it is made directional instead.

Definition at line 235 of file vtkLight.h.

## ◆ DeepCopy()

void vtkLight::DeepCopy | ( | vtkLight * | light | ) |

Perform deep copy of this light.

## ◆ SetLightType()

virtual void vtkLight::SetLightType | ( | int |  | ) |
| virtual

Set/Get the type of the light.

A SceneLight is a light located in the world coordinate space. A light is initially created as a scene light.

A Headlight is always located at the camera and is pointed at the camera's focal point. The renderer is free to modify the position and focal point of the camera at any time.

A CameraLight is also attached to the camera, but is not necessarily located at the camera's position. CameraLights are defined in a coordinate space where the camera is located at (0, 0, 1), looking towards (0, 0, 0) at a distance of 1, with up being (0, 1, 0). CameraLight uses the transform matrix to establish this space.

Note: All SetLightType(), and SetLightTypeTo*() calls clear the light's transform matrix.

## ◆ GetLightType()

virtual int vtkLight::GetLightType | ( |  | ) |
| virtual

Set/Get the type of the light.

A SceneLight is a light located in the world coordinate space. A light is initially created as a scene light.

A Headlight is always located at the camera and is pointed at the camera's focal point. The renderer is free to modify the position and focal point of the camera at any time.

A CameraLight is also attached to the camera, but is not necessarily located at the camera's position. CameraLights are defined in a coordinate space where the camera is located at (0, 0, 1), looking towards (0, 0, 0) at a distance of 1, with up being (0, 1, 0). CameraLight uses the transform matrix to establish this space.

Note: All SetLightType(), and SetLightTypeTo*() calls clear the light's transform matrix.

## ◆ SetLightTypeToHeadlight()

void vtkLight::SetLightTypeToHeadlight | ( |  | ) |
| inline

Set/Get the type of the light.

A SceneLight is a light located in the world coordinate space. A light is initially created as a scene light.

A Headlight is always located at the camera and is pointed at the camera's focal point. The renderer is free to modify the position and focal point of the camera at any time.

A CameraLight is also attached to the camera, but is not necessarily located at the camera's position. CameraLights are defined in a coordinate space where the camera is located at (0, 0, 1), looking towards (0, 0, 0) at a distance of 1, with up being (0, 1, 0). CameraLight uses the transform matrix to establish this space.

Note: All SetLightType(), and SetLightTypeTo*() calls clear the light's transform matrix.

Definition at line 265 of file vtkLight.h.

## ◆ SetLightTypeToSceneLight()

void vtkLight::SetLightTypeToSceneLight | ( |  | ) |
| inline

Set/Get the type of the light.

A SceneLight is a light located in the world coordinate space. A light is initially created as a scene light.

A Headlight is always located at the camera and is pointed at the camera's focal point. The renderer is free to modify the position and focal point of the camera at any time.

A CameraLight is also attached to the camera, but is not necessarily located at the camera's position. CameraLights are defined in a coordinate space where the camera is located at (0, 0, 1), looking towards (0, 0, 0) at a distance of 1, with up being (0, 1, 0). CameraLight uses the transform matrix to establish this space.

Note: All SetLightType(), and SetLightTypeTo*() calls clear the light's transform matrix.

Definition at line 266 of file vtkLight.h.

## ◆ SetLightTypeToCameraLight()

void vtkLight::SetLightTypeToCameraLight | ( |  | ) |
| inline

Set/Get the type of the light.

A SceneLight is a light located in the world coordinate space. A light is initially created as a scene light.

A Headlight is always located at the camera and is pointed at the camera's focal point. The renderer is free to modify the position and focal point of the camera at any time.

A CameraLight is also attached to the camera, but is not necessarily located at the camera's position. CameraLights are defined in a coordinate space where the camera is located at (0, 0, 1), looking towards (0, 0, 0) at a distance of 1, with up being (0, 1, 0). CameraLight uses the transform matrix to establish this space.

Note: All SetLightType(), and SetLightTypeTo*() calls clear the light's transform matrix.

Definition at line 267 of file vtkLight.h.

## ◆ LightTypeIsHeadlight()

int vtkLight::LightTypeIsHeadlight | ( |  | ) |

Query the type of the light.

## ◆ LightTypeIsSceneLight()

int vtkLight::LightTypeIsSceneLight | ( |  | ) |

Query the type of the light.

## ◆ LightTypeIsCameraLight()

int vtkLight::LightTypeIsCameraLight | ( |  | ) |

Query the type of the light.

## ◆ SetShadowAttenuation()

virtual void vtkLight::SetShadowAttenuation | ( | float |  | ) |
| virtual

Set/Get the shadow intensity By default a light will be completely blocked when in shadow by setting this value to less than 1.0 you can control how much light is attenuated when in shadow.

## ◆ GetShadowAttenuation()

virtual float vtkLight::GetShadowAttenuation | ( |  | ) |
| virtual

Set/Get the shadow intensity By default a light will be completely blocked when in shadow by setting this value to less than 1.0 you can control how much light is attenuated when in shadow.

## ◆ GetInformation()

virtual vtkInformation* vtkLight::GetInformation | ( |  | ) |
| virtual

Set/Get the information object associated with the light.

## ◆ SetInformation()

virtual void vtkLight::SetInformation | ( | vtkInformation * |  | ) |
| virtual

Set/Get the information object associated with the light.

## Member Data Documentation

## ◆ FocalPoint

double vtkLight::FocalPoint[3]
| protected

Definition at line 302 of file vtkLight.h.

## ◆ Position

double vtkLight::Position[3]
| protected

Definition at line 303 of file vtkLight.h.

## ◆ Intensity

double vtkLight::Intensity
| protected

Definition at line 304 of file vtkLight.h.

## ◆ AmbientColor

double vtkLight::AmbientColor[3]
| protected

Definition at line 305 of file vtkLight.h.

## ◆ DiffuseColor

double vtkLight::DiffuseColor[3]
| protected

Definition at line 306 of file vtkLight.h.

## ◆ SpecularColor

double vtkLight::SpecularColor[3]
| protected

Definition at line 307 of file vtkLight.h.

## ◆ Switch

vtkTypeBool vtkLight::Switch
| protected

Definition at line 308 of file vtkLight.h.

## ◆ Positional

vtkTypeBool vtkLight::Positional
| protected

Definition at line 309 of file vtkLight.h.

## ◆ Exponent

double vtkLight::Exponent
| protected

Definition at line 310 of file vtkLight.h.

## ◆ ConeAngle

double vtkLight::ConeAngle
| protected

Definition at line 311 of file vtkLight.h.

## ◆ AttenuationValues

double vtkLight::AttenuationValues[3]
| protected

Definition at line 312 of file vtkLight.h.

## ◆ TransformMatrix

vtkMatrix4x4* vtkLight::TransformMatrix
| protected

Definition at line 313 of file vtkLight.h.

## ◆ TransformedFocalPointReturn

double vtkLight::TransformedFocalPointReturn[3]
| protected

Definition at line 314 of file vtkLight.h.

## ◆ TransformedPositionReturn

double vtkLight::TransformedPositionReturn[3]
| protected

Definition at line 315 of file vtkLight.h.

## ◆ LightType

int vtkLight::LightType
| protected

Definition at line 316 of file vtkLight.h.

## ◆ ShadowAttenuation

float vtkLight::ShadowAttenuation
| protected

Definition at line 317 of file vtkLight.h.

## ◆ Information

vtkInformation* vtkLight::Information
| protected

Definition at line 320 of file vtkLight.h.

The documentation for this class was generated from the following file:

- Rendering/Core/vtkLight.h